--===========================================================================
--Original author: Peter Cooper
--Ported, modified and optimized to EUPHORIA native code by HHS
--Hollow Horse Software
--Lucius L. Hilley III  01-03-1998
--James G. Harris

include mode19.e --our graphics engine

if set_screens(2) then
end if

sequence st --sin_table
sequence ct --cos_table
sequence a  --defined_world

st = repeat(0, 361)
ct = st
a = repeat(0, 10)


----------------------------------------
procedure screensetup()
  if graphics_mode(19) then
    puts(2, "Graphics not available.\n")
    abort(0)
  end if
  clear_screen()
end procedure
----------------------------------------
procedure makeworld()
-- Peter Coopers demonstration level. Change it if you wish!
-- Each number is a color number.
  a = repeat(0, 10)
  a[1]  = "1919191919"
  a[2]  = "9000000001"
  a[3]  = "1000000409"
  a[4]  = "9010005001"
  a[5]  = "1020040009"
  a[6]  = "9030000001"
  a[7]  = "1000078009"
  a[8]  = "9050087001"
  a[9]  = "1060000009"
  a[10] = "9191919191"
  a = a - 48
end procedure
----------------------------------------
procedure maketables()
  atom t1, t2

  t1 = 3.14159265 / 180 
  t2 = 0
  for A = 1 to 361 do
    t2 = t2 + t1
    st[A] = sin(t2)
    ct[A] = cos(t2)
  end for
  st = st * 2
  ct = ct * 2
end procedure
----------------------------------------
atom xb, yb, in
atom Bx, By, dd
atom Px, Py, sa, temp, OldPx, OldPy
integer T
integer x, xtemp 
integer l, k
sequence ut

Px = 20
Py = 20
sa = 0

puts(1, "please wait..")
makeworld()
maketables()
screensetup()

CLS(2,2)
mem_set(screen[3], 15, 32000)
mem_set(screen[3], 0, 10)

temp = 310

for A = 1 to 199 do
    mem_set(screen[3]+temp, 0, 20)
    temp = temp + 320
end for    

mem_set(screen[3]+temp, 0, 10)

while 1 do
  screen_copy(1,2)
  T = sa + 59
  for t = sa to T do
    xtemp = remainder(t,360) + 1
    xb = st[xtemp] / 2   --'get inc
    yb = ct[xtemp] / 2   --'get inc
    Bx = Px             --'decimal copy
    By = Py             --'decimal copy
    l = 0               --'reset length
    k = 0
    while k = 0 do
      Bx = Bx + xb
      By = By + yb
      l = l + 1
      k =  a[floor(By / 10)][floor(Bx / 10)] 
    end while
    x  = (t - sa) * 5 + 10
    dd = floor(1000 / l)
    
    if dd > 99 then 
        dd = 99 
    elsif -99 > dd then 
        dd = -99 
    end if
    
    ut = repeat(k,5)
    for u = 99-dd to 100+dd do
       vpixel({x,u},ut,1)
    end for    
    ut = repeat(0,5)
    vpixel({x,99-dd},ut,1)
    vpixel({x,100+dd},ut,1)
  end for
  screen_copy(0,1)
  in = get_key()
  while in = -1 do
    in = get_key()
  end while
  if in = 333 then --right
    sa = sa + 4
  end if
  if in = 331 then --left
    sa = remainder((sa + 356), 360)
  end if
  if in = 27 then
    if graphics_mode(-1) then
    end if
    exit
  end if
  T = floor((T+sa)/2)
  xtemp = remainder(T, 360) + 1
  if in = 328 then -- up
    OldPx = Px
    OldPy = Py
    Px = Px + st[xtemp] 
    Py = Py + ct[xtemp] 
    if a[floor(Py/10)][floor(Px/10)] then
        Px = OldPx
        Py = OldPy
    end if       
  end if
  if in = 336 then -- down
    OldPx = Px
    OldPy = Py
    Px = Px - st[xtemp] 
    Py = Py - ct[xtemp] 
    if a[Py/10][Px/10] > 0 then
        Px = OldPx
        Py = OldPy
     end if   
  end if
end while
if set_screens(0) then
end if

